Index: typo3/sysext/install/mod/class.tx_install.php
===================================================================
--- typo3/sysext/install/mod/class.tx_install.php	(revision 7289)
+++ typo3/sysext/install/mod/class.tx_install.php	(working copy)
@@ -4770,440 +7520,806 @@
 	 **********************/
 
 	/**
-	 * This creates a link to the given $url. If $link is set, that'll be the link-text
-	 *
-	 * @param	[type]		$url: ...
-	 * @param	[type]		$link: ...
-	 * @return	[type]		...
-	 */
-	function linkIt($url,$link='')	{
-		return '<a href="'.$url.'" target="_blank">'.($link?$link:$url).'</a>';
-	}
-
-	/**
 	 * Setting a message in the message-log and sets the fatalError flag if error type is 3.
 	 *
-	 * @param	string		Section header
-	 * @param	string		A short description
-	 * @param	string		A long (more detailed) description
-	 * @param	integer		-1=OK sign, 0=message, 1=notification, 2=warning, 3=error
-	 * @param	boolean		Print message also in "Advanced" mode (not only in 1-2-3 mode)
-	 * @return	void
+	 * @param string $head Section header
+	 * @param string $short_string A short description
+	 * @param string $long_string A long (more detailed) description
+	 * @param integer $type -1=OK sign, 0=message, 1=notification, 2=warning, 3=error
+	 * @param boolean $force Print message also in "Advanced" mode (not only in 1-2-3 mode)
+	 * @return void
 	 */
-	function message($head, $short_string='', $long_string='', $type=0, $force=0)	{
-		if (!$force && $this->mode=='123' && $type<2)	{ return; }	// Return directly if mode-123 is enabled.
+	function message($head, $short_string='', $long_string='', $type=0, $force=0) {
+			// Return directly if mode-123 is enabled.
+		if (!$force && $this->mode=='123' && $type<2) {
+			return;
+		}
 
-		if ($type==3)	{ $this->fatalError=1; }
-		if ($this->messageFunc_nl2br && !preg_match('/<\/table>/', $long_string))	{
-			$long_string = nl2br(trim($long_string));
-		} else {
-			$long_string = trim($long_string);
-		}
+		if ($type==3) { $this->fatalError=1; }
+
+		$long_string = trim($long_string);
+
 		if (!$this->silent)	$this->printSection($head, $short_string, $long_string, $type);
 	}
 
 	/**
 	 * This "prints" a section with a message to the ->sections array
 	 *
-	 * @param	string		Section header
-	 * @param	string		A short description
-	 * @param	string		A long (more detailed) description
-	 * @param	integer		-1=OK sign, 0=message, 1=notification, 2=warning , 3=error
-	 * @return	void
+	 * @param string $head Section header
+	 * @param string $short_string A short description
+	 * @param string $long_string A long (more detailed) description
+	 * @param integer $type -1=OK sign, 0=message, 1=notification, 2=warning , 3=error
+	 * @return void
 	 */
-	function printSection($head, $short_string, $long_string, $type)	{
-		switch($type)	{
+	function printSection($head, $short_string, $long_string, $type) {
+			// Get the template file
+		$templateFile = @file_get_contents(PATH_site . $this->templateFilePath . 'PrintSection.html');
+			// Get the template part from the file
+		$template = $this->contentObject->getSubpart($templateFile, '###TEMPLATE###');
+
+		switch($type) {
 			case 3:
-				$cssClass = ' class="typo3-message message-error"';
+				$messageType = 'message-error';
 			break;
 			case 2:
-				$cssClass = ' class="typo3-message message-warning"';
+				$messageType = 'message-warning';
 			break;
 			case 1:
-				$cssClass =' class="typo3-message message-notice"';
+				$messageType = 'message-notice';
 				break;
 			case 0:
-				$cssClass = ' class="typo3-message message-information"';
+				$messageType = 'message-information';
 				break;
 			case -1:
-				$cssClass = ' class="typo3-message message-ok"';
+				$messageType = 'message-ok';
 			break;
 		}
 
-		if (!trim($short_string))	{
-			$this->sections[$head][]='';
+		if (!trim($short_string)) {
+			$content = '';
 		} else {
-			$this->sections[$head][]='
-			<tr><td' . $cssClass . ' nowrap="nowrap">' . '<strong>' . $this->fw($short_string) . '</strong></td></tr>' . (trim($long_string) ? '
-			<tr><td>' . $this->fw($long_string) . '<br /><br /></td></tr>' : '');
+			if (trim($long_string)) {
+					// Get the subpart for the long string
+				$longStringSubpart = $this->contentObject->getSubpart($template, '###LONGSTRINGAVAILABLE###');
+			}
+				// Substitute the subpart for the long string
+			$content = $this->contentObject->substituteSubpart(
+				$template,
+				'###LONGSTRINGAVAILABLE###',
+				$longStringSubpart
+			);
+				// Define the markers content
+			$markers = array(
+				'messageType' => $messageType,
+				'shortString' => $short_string,
+				'longString' => $long_string
+			);
+				// Fill the markers
+			$content = $this->contentObject->substituteMarkerArray(
+				$content,
+				$markers,
+				'###|###',
+				1,
+				1
+			);
 		}
+		$this->sections[$head][] = $content;
 	}
 
 	/**
-	 * Wraps the str in a font-tag with verdana 1
+	 * This prints all the messages in the ->section array
 	 *
-	 * @param	[type]		$str: ...
-	 * @param	[type]		$size: ...
-	 * @return	[type]		...
+	 * @return string HTML of all the messages
 	 */
-	function fw($str,$size=1)	{
+	function printAll() {
+			// Get the template file
+		$templateFile = @file_get_contents(PATH_site . $this->templateFilePath . 'PrintAll.html');
+			// Get the template part from the file
+		$template = $this->contentObject->getSubpart($templateFile, '###TEMPLATE###');
+		$sections = array();
 
-		if (preg_match('/^<table/', $str) && preg_match('/<\/table>$/', $str)) {
-			// no wrap
-		} else {
-			if($size==1) {
-				$size = 'class="smalltext"';
-			} elseif ($size==2) {
-				$size = 'class="bodytext"';
-			} else {
-				$size = 'size="size'.$size.'text"';
-			}
-			$str = '<span '.$size.'>'.$str.'</span>';
+		foreach ($this->sections as $header => $valArray) {
+				// Get the subpart for sections
+			$sectionSubpart = $this->contentObject->getSubpart($template, '###SECTIONS###');
+				// Define the markers content
+			$sectionMarkers = array(
+				'header' => $header . ':',
+				'sectionContent' => implode(chr(10), $valArray)
+			);
+				// Fill the markers in the subpart
+			$sections[] = $this->contentObject->substituteMarkerArray(
+				$sectionSubpart,
+				$sectionMarkers,
+				'###|###',
+				1,
+				1
+			);
 		}
-		return $str;
-	}
+			// Substitute the subpart for the sections
+		$content = $this->contentObject->substituteSubpart(
+			$template,
+			'###SECTIONS###',
+			implode(chr(10), $sections)
+		);
 
-	/**
-	 * Wraps the str in a font-tag with verdana 1
-	 *
-	 * @param	[type]		$str: ...
-	 * @return	[type]		...
-	 */
-	function fwheader($str)	{
-		return '<div align="center"><strong>'.$this->fw($str,3).'</strong></div>';
+		return $content;
 	}
 
 	/**
-	 * Wrapping labal/content in a table-row.
+	 * This wraps and returns the main content of the page into proper html-code.
 	 *
-	 * @param	[type]		$label: ...
-	 * @param	[type]		$content: ...
-	 * @return	[type]		...
+	 * @param string $content The page content
+	 * @return string The full HTML page
 	 */
-	function wrapInCells($label,$content)	{
-		return '<tr><td valign="top" nowrap="nowrap"><strong>'.$this->fw($label).'</strong></td><td>&nbsp;</td><td valign="top">'.$this->fw($content).'<br /></td></tr>';
-	}
+	function outputWrapper($content) {
+			// Get the template file
+		if (!$this->passwordOK) {
+			$this->template = @file_get_contents(PATH_site . $this->templateFilePath . 'Install_login.html');
+		} elseif ($this->mode == '123') {
+			$this->template = @file_get_contents(PATH_site . $this->templateFilePath . 'Install_123.html');
+		} else {
+			$this->template = @file_get_contents(PATH_site . $this->templateFilePath . 'Install.html');
+		}
 
-	/**
-	 * This prints all the messages in the ->section array
-	 *
-	 * @return	[type]		...
-	 */
-	function printAll()	{
-		reset($this->sections);
-		$out='';
-		while(list($header,$valArray)=each($this->sections))	{
-			$out.='
-			<tr><td>&nbsp;</td></tr>
-			<tr><td><div align="center"><strong>'.$this->fw($header.':',2).'</strong></div></td></tr>
-			';
-			$out.=implode($valArray,chr(10));
+			// Include the default stylesheets
+		$this->stylesheets[] = '<link rel="stylesheet" type="text/css" href="' .
+			$this->backPath .
+			'sysext/install/Resources/Public/Stylesheets/reset.css" />';
+		$this->stylesheets[] = '<link rel="stylesheet" type="text/css" href="' .
+			$this->backPath .
+			'sysext/install/Resources/Public/Stylesheets/general.css" />';
+
+			// Include the stylesheets based on screen
+		if ($this->mode == '123') {
+			$this->stylesheets[] = '<link rel="stylesheet" type="text/css" href="' .
+				$this->backPath .
+				'sysext/install/Resources/Public/Stylesheets/install_123.css" />';
+		} elseif ($this->passwordOK) {
+			$this->stylesheets[] = '<link rel="stylesheet" type="text/css" href="' .
+				$this->backPath .
+				'sysext/install/Resources/Public/Stylesheets/install.css" />';
+			if (!$this->session->inBackend()) {
+				$this->stylesheets[] = '<link rel="stylesheet" type="text/css" href="' .
+					$this->backPath .
+					'sysext/install/Resources/Public/Stylesheets/install_standalone.css" />';
+			}
+		} else {
+			$this->stylesheets[] = '<link rel="stylesheet" type="text/css" href="' .
+				$this->backPath .
+				'sysext/install/Resources/Public/Stylesheets/install_login.css" />';
+			if (!$this->session->inBackend()) {
+				$this->stylesheets[] = '<link rel="stylesheet" type="text/css" href="' .
+					$this->backPath .
+					'sysext/install/Resources/Public/Stylesheets/install_standalone.css" />';
+			}
 		}
-		return '<table border="0" cellpadding="2" cellspacing="2">'.$out.'</table>';
-	}
 
-	/**
-	 * This wraps and returns the main content of the page into proper html-code.
-	 *
-	 * @param	string		The page content
-	 * @return	string		The full HTML page
-	 */
-	function outputWrapper($content)	{
-		$out='
-<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
-   "http://www.w3.org/TR/html4/loose.dtd">
-<html>
-<head>
-<meta http-equiv="Content-Type" content="text/html; charset='.($GLOBALS['TYPO3_CONF_VARS']['BE']['forceCharset']?$GLOBALS['TYPO3_CONF_VARS']['BE']['forceCharset']:'iso-8859-1').'" />
-'.$this->headerStyle.'
-		<link rel="stylesheet" type="text/css" href="'.$this->backPath.'sysext/install/mod/install.css" >
- 		<title>TYPO3 Install Tool</title>
-		'.($this->JSmessage?'
-<script language="javascript" type="text/javascript">alert(unescape(\'' . t3lib_div::rawUrlEncodeJS($this->JSmessage) . '\'));</script>
+			// Include javascript message
+		$this->javascript[] = $this->JSmessage ?
+			'<script type="text/javascript">alert(unescape(\'' . t3lib_div::rawUrlEncodeJS($this->JSmessage) . '\'));</script>' :
+			'';
 
-		':'').'
-<script type="text/javascript" src="../contrib/prototype/prototype.js"></script>
-	</head>
-	<body>'.$this->contentBeforeTable.'
-		<div align="center">';
-		if($this->INSTALL['type'] == 'about') {
-			$out .= '<table class="smallOuterTable" border="0" cellspacing="0" cellpadding="0">';
+			// Define the markers content
+		if ($this->mode == '123') {
+			$this->markers['headTitle'] = 'Installing TYPO3 ' . TYPO3_branch;
 		} else {
-			$out .= '<table class="outerTable" border="0" cellspacing="0" cellpadding="0">';
+			$this->markers['headTitle'] = '
+				TYPO3 ' . TYPO3_version . '
+				Install tool on site: ' . $GLOBALS['TYPO3_CONF_VARS']['SYS']['sitename'] . '
+			';
 		}
-		$out .= '<tr>
-			<td class="logo"><img src="'.$this->backPath.'gfx/typo3logo.gif" width="123" height="34" vspace="10" hspace="50" alt="TYPO3"></td>
-		</tr>
-		<tr>
-			<td class="createBorder">
-				<table width="100%" border="0" cellspacing="1" cellpadding="10">
-					<tr>
-						<td class="generalTableBackground">
-						<div align="center"><span class="size4text"><strong>TYPO3 '.TYPO3_branch.' Install Tool</strong></span></div>
-						<div align="center"><span class="siteInfo"><strong>Site: '.$GLOBALS['TYPO3_CONF_VARS']['SYS']['sitename'].'</strong></span></div>
-						'.($this->passwordOK ? '<div align="center"><span class="siteInfo"><strong>Version: '.TYPO3_version.'</strong></span></div>':'').'<br />
+		$this->markers['title'] = 'TYPO3 ' . TYPO3_version;
+		$this->markers['javascript'] = implode(chr(10), $this->javascript);
+		$this->markers['stylesheets'] = implode(chr(10), $this->stylesheets);
+		$this->markers['llErrors'] = 'The following errors occured';
+		$this->markers['copyright'] = $this->copyright();
+		$this->markers['charset'] = $GLOBALS['TYPO3_CONF_VARS']['BE']['forceCharset'] ? $GLOBALS['TYPO3_CONF_VARS']['BE']['forceCharset'] : 'iso-8859-1';
+		$this->markers['backendUrl'] = '../index.php';
+		$this->markers['backend'] = 'Backend admin';
+		$this->markers['frontendUrl'] = '../../index.php';
+		$this->markers['frontend'] = 'Frontend website';
 
-'.($this->step?$this->stepHeader():$this->menu()).$content.'<hr />'.$this->note123().$this->endNotes().'
-						</td>
-					</tr>
-				</table>
-			</td>
-		</tr>
-		</table>
-		</div>
-	</body>
-</html>';
-		return $out;
+		$this->markers['metaCharset'] = 'Content-Type" content="text/html; charset=';
+		if (!empty($GLOBALS['TYPO3_CONF_VARS']['BE']['forceCharset'])) {
+			$this->markers['metaCharset'] .= $GLOBALS['TYPO3_CONF_VARS']['BE']['forceCharset'];
+		} else {
+			$this->markers['metaCharset'] .= 'iso-8859-1';
+		}
+
+			// Add the error messages
+		if (!empty($this->errorMessages)) {
+				// Get the subpart for all error messages
+			$errorMessagesSubPart = $this->contentObject->getSubpart($this->template, '###ERRORMESSAGES###');
+				// Get the subpart for a single error message
+			$errorMessageSubPart = $this->contentObject->getSubpart($errorMessagesSubPart, '###MESSAGES###');
+			$errors = array();
+
+			foreach ($this->errorMessages as $errorMessage) {
+					// Define the markers content
+				$errorMessageMarkers = array(
+					'message' => $errorMessage
+				);
+					// Fill the markers in the subpart
+				$errors[] = $this->contentObject->substituteMarkerArray(
+					$errorMessageSubPart,
+					$errorMessageMarkers,
+					'###|###',
+					1,
+					1
+				);
+			}
+				// Substitute the subpart for a single message
+			$errorMessagesSubPart = $this->contentObject->substituteSubpart(
+				$errorMessagesSubPart,
+				'###MESSAGES###',
+				implode(chr(10), $errors)
+			);
+		}
+
+			// Version subpart is only allowed when password is ok
+		if ($this->passwordOK) {
+				// Get the subpart for the version
+			$versionSubPart = $this->contentObject->getSubpart($this->template, '###VERSIONSUBPART###');
+				// Define the markers content
+			$versionSubPartMarkers['version'] = 'Version: ' . TYPO3_version;
+				// Fill the markers in the subpart
+			$versionSubPart = $this->contentObject->substituteMarkerArray(
+				$versionSubPart,
+				$versionSubPartMarkers,
+				'###|###',
+				1,
+				1
+			);
+		}
+			// Substitute the version subpart
+		$this->template = $this->contentObject->substituteSubpart(
+			$this->template,
+			'###VERSIONSUBPART###',
+			$versionSubPart
+		);
+			// Substitute the menu subpart
+		$this->template = $this->contentObject->substituteSubpart(
+			$this->template,
+			'###MENU###',
+			$this->menu()
+		);
+			// Substitute the error messages subpart
+		$this->template = $this->contentObject->substituteSubpart(
+			$this->template,
+			'###ERRORMESSAGES###',
+			$errorMessagesSubPart
+		);
+			// Substitute the content subpart
+		$this->template = $this->contentObject->substituteSubpart(
+			$this->template,
+			'###CONTENT###',
+			$content
+		);
+			// Fill the markers
+		$this->template = $this->contentObject->substituteMarkerArray(
+			$this->template,
+			$this->markers,
+			'###|###',
+			1,
+			1
+		);
+
+		return $this->template;
 	}
 
 	/**
 	 * Sends the page to the client.
 	 *
-	 * @param	string		The HTML page
+	 * @param string $content The HTML page
+	 * @return void
 	 */
-	function output($content)	{
+	function output($content) {
 		header ('Content-Type: text/html; charset=' .
 			($GLOBALS['TYPO3_CONF_VARS']['BE']['forceCharset']?$GLOBALS['TYPO3_CONF_VARS']['BE']['forceCharset']:'iso-8859-1'));
 		echo $content;
 	}
 
 	/**
-	 * [Describe function...]
+	 * Generates the main menu
 	 *
-	 * @return	[type]		...
+	 * @return string HTML of the main menu
 	 */
-	function menu()	{
-		if (!$this->passwordOK)	return;
+	function menu() {
+		if ($this->mode !='123') {
+			if (!$this->passwordOK)	return;
 
-		reset($this->menuitems);
-		$c=0;
-		$out=array();
-		while(list($k,$v)=each($this->menuitems))	{
-			$bgcolor = ($this->INSTALL['type']==$k ? ' class="activeMenu"' : ' class="generalTableBackground"');
-			$c++;
-			$out[]='<tr><td'.$bgcolor.'><a href="'.htmlspecialchars($this->scriptSelf.'?TYPO3_INSTALL[type]='.$k.($this->mode?'&mode='.rawurlencode($this->mode):'')).'">'.$this->fw($c.': '.$v).'</a></td></tr>';
+			$c = 0;
+			$items = array();
+				// Get the subpart for the main menu
+			$menuSubPart = $this->contentObject->getSubpart($this->template, '###MENU###');
+				// Get the subpart for each single menu item
+			$menuItemSubPart = $this->contentObject->getSubpart($this->template, '###MENUITEM###');
+
+			foreach ($this->menuitems as $k => $v) {
+					// Define the markers content
+				$markers = array(
+					'class' => ($this->INSTALL['type']==$k ? 'class="act"' : ''),
+					'id' => $k,
+					'url' => htmlspecialchars(
+						$this->scriptSelf .
+						'?TYPO3_INSTALL[type]=' .
+						$k .
+						($this->mode ? '&mode=' . rawurlencode($this->mode) : '')
+					),
+					'item' => $v
+				);
+					// Fill the markers in the subpart
+				$items[] = $this->contentObject->substituteMarkerArray(
+					$menuItemSubPart,
+					$markers,
+					'###|###',
+					1,
+					1
+				);
+			}
+				// Substitute the subpart for the single menu items
+			$menuSubPart = $this->contentObject->substituteSubpart(
+				$menuSubPart,
+				'###MENUITEM###',
+				implode(chr(10), $items)
+			);
+
+			return $menuSubPart;
 		}
-
-		$code = '<table border="0" cellpadding="0" cellspacing="1">'.implode($out,chr(10)).'</table>';
-		$code = '<table border="0" cellpadding="0" cellspacing="0" id="menu"><tr><td>'.$code.'</td></tr></table>';
-		return '<div align="center">'.$code.'</div>';
 	}
 
 	/**
-	 * [Describe function...]
+	 * Generates the step header for 1-2-3 mode, the numbers at the top
 	 *
-	 * @return	[type]		...
+	 * @return string HTML for the step header
 	 */
-	function stepHeader()	{
-		$msg1='Type in your database parameters here:';
-		$msg2='Database';
-		$msg3='Import the database sql-file';
-		$msg4='You\'re done!';
-		$out='<img src="'.$this->backPath.'gfx/123_'.$this->step.'.png" width="402" height="73" border="0" alt="" usemap="#id123_print_Map">
-<map name="id123_print_Map">
-<area title="'.$msg4.'" shape="poly" alt="" coords="299,35, 303,19, 313,9, 335,5, 366,6, 379,11, 388,21, 392,35, 390,47, 381,58, 376,64, 359,67, 320,66, 307,60, 302,51, 300,44" href="'.htmlspecialchars($this->scriptSelf.'?mode='.$this->mode.'&step=go').'">
-<area title="'.$msg3.'" shape="circle" alt="" coords="234,36,32" href="'.htmlspecialchars($this->scriptSelf.'?mode='.$this->mode.'&step=3').'">
-<area title="'.$msg2.'" shape="circle" alt="" coords="136,37,30" href="'.htmlspecialchars($this->scriptSelf.'?mode='.$this->mode.'&step=2').'">
-<area title="'.$msg1.'" shape="circle" alt="" coords="40,36,29" href="'.htmlspecialchars($this->scriptSelf.'?mode='.$this->mode.'&step=1').'">
-</map>
+	function stepHeader() {
+			// Get the template file
+		$templateFile = @file_get_contents(PATH_site . $this->templateFilePath . 'StepHeader.html');
+			// Get the template part from the file
+		$template = $this->contentObject->getSubpart($templateFile, '###TEMPLATE###');
+			// Get the subpart for each item
+		$stepItemSubPart = $this->contentObject->getSubpart($template, '###STEPITEM###');
 
+		$steps = array();
 
-		<br />';
-		$msg='';
-		switch(strtolower($this->step))	{
-			case 1:
-				$msg=$msg1;
-			break;
-			case 2:
-				$msg=$msg2;
-			break;
-			case 3:
-				$msg=$msg3;
-			break;
-			case 'go':
-				$msg=$msg4;
-			break;
-			default:
-			break;
+		for ($counter = 2; $counter <= $this->totalSteps; $counter++) {
+			$state = '';
+
+			if ($this->step === $counter) {
+				$state = 'act';
+			} elseif ($this->step === 'go' || $counter < $this->step) {
+				$state = 'done';
+			}
+				// Define the markers content
+			$stepItemMarkers = array(
+				'class' => 'class="step' . ($counter - 1) . ($state ? ' ' . $state : '') . '"',
+				'url' => $this->scriptSelf . '?mode=' . $this->mode . '&amp;step=' . $counter,
+				'step' => $counter
+			);
+				// Fill the markers in the subpart
+			$steps[] = $this->contentObject->substituteMarkerArray(
+				$stepItemSubPart,
+				$stepItemMarkers,
+				'###|###',
+				1,
+				1
+			);
 		}
-		$out.='<br /><div align="center"><strong>'.$this->fw($msg,2).'</strong></div>';
+			// Substitute the subpart for the items
+		$content = $this->contentObject->substituteSubpart(
+			$template,
+			'###STEPITEM###',
+			implode(chr(10), $steps)
+		);
 
-		return $out;
+		return $content;
 	}
 
 	/**
-	 * [Describe function...]
+	 * Generate HTML for the security risk message
 	 *
-	 * @return	[type]		...
+	 * @return string HTML for the security risk message
 	 */
-	function note123()	{
-		if ($this->mode=='123')	{
-			$c='<table border="0" cellpadding="0" cellspacing="0" width="100%">
-				<tr><td class="notice" nowrap="nowrap"><img src="' . $this->backPath . 'gfx/icon_note.gif" width="18" height="16" align="top" alt=""><strong>' . $this->fontTag1 . 'NOTICE: Install Tool is running in \'123\' mode. <a href="' . $this->scriptSelf . '">Click here to disable.</a></span></strong></td></tr>
-			</table>';
-			return $c;
-		}
+	function securityRisk() {
+		return '
+			<p>
+				This script is a
+				<strong>great danger to the security of TYPO3</strong>
+				if you don\'t secure it somehow.
+				<br />
+				We suggest one of the following:
+			</p>
+			<ul>
+				<li>
+					Change the password as defined by the md5-hash in
+					TYPO3_CONF_VARS[BE][installToolPassword]
+				</li>
+				<li>
+					Delete the folder \'typo3/install/\' with this script in or
+					just insert an \'exit;\' line in the script-file there
+				</li>
+				<li>
+					Password protect the \'typo3/install/\' folder, eg. with a
+					.htaccess file
+				</li>
+			</ul>
+			<p>
+				The TYPO3_CONF_VARS[BE][installToolPassword] is always active,
+				but choosing one of the other options will improve security and
+				is recommended highly.
+			</p>
+		';
 	}
 
 	/**
-	 * [Describe function...]
+	 * Generates the form to alter the password of the install tool
 	 *
-	 * @return	[type]		...
+	 * @return string HTML of the form
 	 */
-	function endNotes()	{
-		if ($this->mode!='123' && $this->passwordOK)	{
-			$c.='OS detected: <strong>'.(TYPO3_OS=='WIN'?'WIN':'UNIX').'</strong><br />';
-			$c.='UNIX/CGI detected: <strong>'.(PHP_SAPI=='cgi' ? 'YES' : 'NO').'</strong><br />';
-			$c.='PATH_thisScript: <strong>'.PATH_thisScript.'</strong><br />';
-			$c.='<br />';
-			$c.='<a href="../index.php" target="install_backend">Backend admin in new window.</a><br />';
-			$c.='<a href="../../index.php" target="install_frontend">Frontend website in new window.</a><br />';
+	function alterPasswordForm() {
+			// Get the template file
+		$templateFile = @file_get_contents(PATH_site . $this->templateFilePath . 'AlterPasswordForm.html');
+			// Get the template part from the file
+		$template = $this->contentObject->getSubpart($templateFile, '###TEMPLATE###');
+			// Define the markers content
+		$markers = array(
+			'action' => $this->scriptSelf.'?TYPO3_INSTALL[type]=extConfig',
+			'enterPassword' => 'Enter new password:',
+			'enterAgain' => 'Enter again:',
+			'submit' => 'Set new password'
+		);
+			// Fill the markers
+		$content = $this->contentObject->substituteMarkerArray(
+			$template,
+			$markers,
+			'###|###',
+			1,
+			1
+		);
 
-			return $this->fw($c);
-		}
+		return $content;
 	}
 
 	/**
-	 * Convert a size from human-readable form into bytes
+	 * Generate HTML for the copyright
 	 *
-	 * @param	string		A string containing the size in bytes, kilobytes or megabytes. Example: 64M
-	 * @return	string		The string is returned in bytes and can also hold floating values
+	 * @return string HTML of the copyright
 	 */
-	function convertByteSize($bytes)	{
-		if (stristr($bytes,'m'))	{
-			$bytes=doubleval($bytes)*1024*1024;
-		} elseif (stristr($bytes,'k'))	{
-			$bytes=doubleval($bytes)*1024;
-		}
-		return $bytes;
-	}
-
-	/**
-	 * [Describe function...]
-	 *
-	 * @return	[type]		...
-	 */
-	function securityRisk()	{
-		$c='This script is a <strong>great danger to the security of TYPO3</strong> if you don\'t secure it somehow.
-			We suggest one of the following:
-
-			- change the password as defined by the md5-hash in TYPO3_CONF_VARS[BE][installToolPassword].
-			- delete the folder \'typo3/install/\' with this script in or just insert an \'exit;\' line in the script-file there.
-			- password protect the \'typo3/install/\' folder, eg. with a .htaccess file
-
-			The TYPO3_CONF_VARS[BE][installToolPassword] is always active, but choosing one of the other options will improve security and is recommended highly.
+	function copyright() {
+		$content = '
+			<p>
+				<strong>TYPO3 CMS.</strong> Copyright © 1998-' . date('Y') . '
+				Kasper Skårhøj. Extensions are copyright of their respective
+				owners. Go to <a href="http://typo3.com/">http://typo3.com/</a>
+				for details. TYPO3 comes with ABSOLUTELY NO WARRANTY;
+				<a href="http://typo3.com/1316.0.html">click</a> for details.
+				This is free software, and you are welcome to redistribute it
+				under certain conditions; click for details. Obstructing the
+				appearance of this notice is prohibited by law.
+			</p>
+			<p>
+				<a href="http://typo3.org/donate"><strong>Donate</strong></a> |
+				<a href="http://typo3.org">TYPO3.org</a>
+			</p>
 		';
-		return $c;
-	}
 
-	/**
-	 * [Describe function...]
-	 *
-	 * @return	[type]		...
-	 */
-	function alterPasswordForm()	{
-			$content = '<form action="'.$this->scriptSelf.'?TYPO3_INSTALL[type]=extConfig" method="post">
-			Enter new password:
-			<input type="password" name="TYPO3_INSTALL[extConfig][BE][installToolPassword]" /><br />Enter again:
-			<input type="password" name="installToolPassword_check" />
-			<input type="hidden" name="installToolPassword_md5" value="1" />
-			<input type="submit" value="Set new password" /><br />
-			</form>';
-			return $content;
+		return $content;
 	}
 
 	/**
-	 * [Describe function...]
+	 * Generate HTML for the message that the basic setup has been finished
 	 *
-	 * @return	[type]		...
+	 * @return string HTML of the message
 	 */
-	function messageBasicFinished()	{
-		$msg ='
+	function messageBasicFinished() {
+		return '
+			<p>
 				Apparently you have completed the basic setup of the TYPO3 database.
+				<br />
 				Now you can choose between these options:
-
-				- <a href="../../index.php"><strong>Go to the frontend pages</strong></a>
-
-				- <a href="../index.php"><strong>Go to the backend login</strong></a>
-				 (username may be: <i>admin</i>, password may be: <i>password</i>.)
-
-				- <a href="'.$this->scriptSelf.'"><strong>Continue to configure TYPO3</strong></a> (Recommended).
-				 This will let you analyse and verify that everything in your PHP installation is alright. Also if you want to configure TYPO3 to use all the cool features, you <em>must</em> dig into the this!
-				';
-		return $msg;
+			</p>
+			<ul>
+				<li>
+					<a href="../../index.php">
+						Go to the frontend pages
+					</a>
+				</li>
+				<li>
+					<a href="../index.php">
+						Go to the backend login
+					</a>
+					<br />
+			 		(username may be: <em>admin</em>, password may be: <em>password</em>.)
+				</li>
+				<li>
+					<a href="' . $this->scriptSelf . '">
+						Continue to configure TYPO3
+					</a> (Recommended).
+					<br />
+			 		This will let you analyse and verify that everything in your
+			 		PHP installation is alright. Also if you want to configure
+			 		TYPO3 to use all the cool features, you <em>must</em> dig
+			 		into the this!
+			 	</li>
+			 </ul>
+		';
 	}
 
 	/**
-	 * [Describe function...]
+	 * Make the url of the script according to type, mode and step
 	 *
-	 * @param	[type]		$type: ...
-	 * @return	[type]		...
+	 * @param string $type The type
+	 * @return string The url
 	 */
-	function setScriptName($type)	{
+	function setScriptName($type) {
 		$value = $this->scriptSelf.'?TYPO3_INSTALL[type]='.$type.($this->mode?'&mode='.rawurlencode($this->mode):'').($this->step?'&step='.rawurlencode($this->step):'');
 		return $value;
 	}
 
 	/**
-	 * [Describe function...]
+	 * Return the filename that will be used for the backup.
+	 * It is important that backups of PHP files still stay as a PHP file, otherwise they could be viewed un-parsed in clear-text.
 	 *
-	 * @param	[type]		$size: ...
-	 * @param	[type]		$textarea: ...
-	 * @param	[type]		$styleOverride: ...
-	 * @return	[type]		...
+	 * @param string $filename Full path to a file
+	 * @return string The name of the backup file (again, including the full path)
 	 */
-	function formWidth($size=48,$textarea=0,$styleOverride='') {
-			// Input or text-field attribute (size or cols)
-		$wAttrib = $textarea?'cols':'size';
-		if (!$GLOBALS['CLIENT']['FORMSTYLE'])	{	// If not setting the width by style-attribute
-			$size = ceil($size*1);
-			$retVal = ' '.$wAttrib.'="'.$size.'"';
-		} else {	// Setting width by style-attribute. "cols" MUST be avoided with NN6+
-			$pixels = ceil($size*10);
-			$retVal = $styleOverride ? ' style="'.$styleOverride.'"' : ' style="width:'.$pixels.'px;"';
+	function getBackupFilename($filename) {
+		if (preg_match('/\.php$/', $filename)) {
+			$backupFile = str_replace('.php', '_bak.php', $filename);
+		} else {
+			$backupFile = $filename.'~';
 		}
-		return $retVal;
+
+		return $backupFile;
 	}
 
 	/**
-	 * [Describe function...]
+	 * Creates a table which checkboxes for updating database.
 	 *
-	 * @param	[type]		$size: ...
-	 * @param	[type]		$styleOverride: ...
-	 * @param	[type]		$wrap: ...
-	 * @return	[type]		...
+	 * @param array $arr Array of statements (key / value pairs where key is used for the checkboxes)
+	 * @param string $label Label for the table.
+	 * @param boolean $checked If set, then checkboxes are set by default.
+	 * @param boolean $iconDis If set, then icons are shown.
+	 * @param array $currentValue Array of "current values" for each key/value pair in $arr. Shown if given.
+	 * @param boolean $cVfullMsg If set, will show the prefix "Current value" if $currentValue is given.
+	 * @return string HTML table with checkboxes for update. Must be wrapped in a form.
 	 */
-	function formWidthText($size=48,$styleOverride='',$wrap='') {
-		$wTags = $this->formWidth($size,1,$styleOverride);
-			// Netscape 6+ seems to have this ODD problem where there WILL ALWAYS be wrapping with the cols-attribute set and NEVER without the col-attribute...
-		if (strtolower(trim($wrap))!='off' && $GLOBALS['CLIENT']['BROWSER']=='net' && $GLOBALS['CLIENT']['VERSION']>=5)	{
-			$wTags.=' cols="'.$size.'"';
+	function generateUpdateDatabaseForm_checkboxes($arr,$label,$checked=1,$iconDis=0,$currentValue=array(),$cVfullMsg=0) {
+		$out = array();
+		$tableId = uniqid('table');
+		$templateMarkers = array();
+		if (is_array($arr)) {
+				// Get the template file
+			$templateFile = @file_get_contents(PATH_site . $this->templateFilePath . 'GenerateUpdateDatabaseFormCheckboxes.html');
+				// Get the template part from the file
+			$content = $this->contentObject->getSubpart($templateFile, '###TEMPLATE###');
+				// Define the markers content
+			$templateMarkers = array(
+				'label' => $label,
+				'tableId' => $tableId
+			);
+				// Select/Deselect All
+			if (count($arr) > 1) {
+					// Get the subpart for multiple tables
+				$multipleTablesSubpart = $this->contentObject->getSubpart($content, '###MULTIPLETABLES###');
+					// Define the markers content
+				$multipleTablesMarkers = array(
+					'label' => $label,
+					'tableId' => $tableId,
+					'checked' => ($checked ? ' checked="checked"' : ''),
+					'selectAllId' => $tableId . '-checkbox',
+					'selectDeselectAll' => 'select/deselect all'
+				);
+					// Fill the markers in the subpart
+				$multipleTablesSubpart = $this->contentObject->substituteMarkerArray(
+					$multipleTablesSubpart,
+					$multipleTablesMarkers,
+					'###|###',
+					1,
+					1
+				);
+			}
+				// Substitute the subpart for multiple tables
+			$content = $this->contentObject->substituteSubpart(
+				$content,
+				'###MULTIPLETABLES###',
+				$multipleTablesSubpart
+			);
+				// Rows
+			foreach ($arr as $key => $string) {
+					// Get the subpart for rows
+				$rowsSubpart = $this->contentObject->getSubpart($content, '###ROWS###');
+				$currentSubpart = '';
+				$ico = '';
+				$warnings = array();
+					// Define the markers content
+				$rowsMarkers = array(
+					'checkboxId' => 'db-' . $key,
+					'name' => $this->dbUpdateCheckboxPrefix . '[' . $key . ']',
+					'checked' => ($checked ? 'checked="checked"' : ''),
+					'string' => htmlspecialchars($string)
+				);
+
+				if ($iconDis) {
+					$iconMarkers['backPath'] = $this->backPath;
+					if (preg_match('/^TRUNCATE/i', $string)) {
+						$iconMarkers['iconText'] = '';
+						$warnings['clear_table_info'] = 'Clearing the table is sometimes neccessary when adding new keys. In case of cache_* tables this should not hurt at all. However, use it with care.';
+					} elseif (stristr($string,' user_')) {
+						$iconMarkers['iconText'] = '(USER)';
+					} elseif (stristr($string,' app_')) {
+						$iconMarkers['iconText'] = '(APP)';
+					} elseif (stristr($string,' ttx_') || stristr($string,' tx_')) {
+						$iconMarkers['iconText'] = '(EXT)';
+					}
+
+					if (!empty($iconMarkers)) {
+							// Get the subpart for icons
+						$iconSubpart = $this->contentObject->getSubpart($content, '###ICONAVAILABLE###');
+							// Fill the markers in the subpart
+						$iconSubpart = $this->contentObject->substituteMarkerArray(
+							$iconSubpart,
+							$iconMarkers,
+							'###|###',
+							1,
+							1
+						);
+					}
+				}
+					// Substitute the subpart for icons
+				$rowsSubpart = $this->contentObject->substituteSubpart(
+					$rowsSubpart,
+					'###ICONAVAILABLE###',
+					$iconSubpart
+				);
+
+				if (isset($currentValue[$key])) {
+						// Get the subpart for current
+					$currentSubpart = $this->contentObject->getSubpart($rowsSubpart, '###CURRENT###');
+						// Define the markers content
+					$currentMarkers = array (
+						'message' => (!$cVfullMsg ? 'Current value:': ''),
+						'value' => $currentValue[$key]
+					);
+						// Fill the markers in the subpart
+					$currentSubpart = $this->contentObject->substituteMarkerArray(
+						$currentSubpart,
+						$currentMarkers,
+						'###|###',
+						1,
+						1
+					);
+				}
+					// Substitute the subpart for current
+				$rowsSubpart = $this->contentObject->substituteSubpart(
+					$rowsSubpart,
+					'###CURRENT###',
+					$currentSubpart
+				);
+					// Fill the markers in the subpart
+				$rowsSubpart = $this->contentObject->substituteMarkerArray(
+					$rowsSubpart,
+					$rowsMarkers,
+					'###|###',
+					1,
+					1
+				);
+
+				$rows[] = $rowsSubpart;
+			}
+				// Substitute the subpart for rows
+			$content = $this->contentObject->substituteSubpart(
+				$content,
+				'###ROWS###',
+				implode(chr(10), $rows)
+			);
+
+			if (count($warnings)) {
+					// Get the subpart for warnings
+				$warningsSubpart = $this->contentObject->getSubpart($content, '###WARNINGS###');
+
+				foreach ($warnings as $warning) {
+						// Get the subpart for single warning items
+					$warningItemSubpart = $this->contentObject->getSubpart($warningsSubpart, '###WARNINGITEM###');
+						// Define the markers content
+					$warningItemMarker['warning'] = $warning;
+						// Fill the markers in the subpart
+					$warningItem[] = $this->contentObject->substituteMarkerArray(
+						$warningItemSubpart,
+						$warningItemMarker,
+						'###|###',
+						1,
+						1
+					);
+				}
+					// Substitute the subpart for single warning items
+				$warningsSubpart = $this->contentObject->substituteSubpart(
+					$warningsSubpart,
+					'###WARNINGITEM###',
+					implode(chr(10), $warningItems)
+				);
+			}
+				// Substitute the subpart for warnings
+			$content = $this->contentObject->substituteSubpart(
+				$content,
+				'###WARNINGS###',
+				implode(chr(10), $warningsSubpart)
+			);
 		}
-		return $wTags;
+			// Fill the markers
+		$content = $this->contentObject->substituteMarkerArray(
+			$content,
+			$templateMarkers,
+			'###|###',
+			1,
+			1
+		);
+
+		return $content;
 	}
 
 	/**
-	 * Return the filename that will be used for the backup.
-	 * It is important that backups of PHP files still stay as a PHP file, otherwise they could be viewed un-parsed in clear-text.
+	 * Returns HTML-code, which is a visual representation of a multidimensional array
+	 * Returns false if $array_in is not an array
 	 *
-	 * @param	string		Full path to a file
-	 * @return	string		The name of the backup file (again, including the full path)
+	 * @param mixed $incomingValue Array to view
+	 * @return string HTML output
 	 */
-	function getBackupFilename($filename)	{
-		if (preg_match('/\.php$/', $filename))	{
-			$backupFile = str_replace('.php', '_bak.php', $filename);
-		} else {
-			$backupFile = $filename.'~';
+	function viewArray($incomingValue) {
+			// Get the template file
+		$templateFile = @file_get_contents(PATH_site . $this->templateFilePath . 'ViewArray.html');
+
+		if (is_array($incomingValue) && !empty($incomingValue)) {
+				// Get the template part from the file
+			$content = $this->contentObject->getSubpart($templateFile, '###TEMPLATE###');
+				// Get the subpart for a single item
+			$itemSubpart = $this->contentObject->getSubpart($content, '###ITEM###');
+
+			foreach ($incomingValue as $key => $value) {
+				if (is_array($value)) {
+					$description = $this->viewArray($value);
+				} elseif (is_object($value)) {
+					$description = get_class($value);
+					if (method_exists($value, '__toString')) {
+						$description .= ': ' . (string)$value;
+					}
+				} else {
+					if (gettype($value) == 'object') {
+						$description = 'Unknown object';
+					} else {
+						$description = htmlspecialchars((string) $value);
+					}
+				}
+					// Define the markers content
+				$itemMarkers = array(
+					'key' => htmlspecialchars((string) $key),
+					'description' => !empty($description) ? $description : '&nbsp;'
+				);
+					// Fill the markers in the subpart
+				$items[] = $this->contentObject->substituteMarkerArray(
+					$itemSubpart,
+					$itemMarkers,
+					'###|###',
+					1,
+					1
+				);
+			}
+				// Substitute the subpart for single item
+			$content = $this->contentObject->substituteSubpart(
+				$content,
+				'###ITEM###',
+				implode(chr(10), $items)
+			);
 		}
-
-		return $backupFile;
+		return $content;
 	}
 
 	/**
 	 * Returns a newly created TYPO3 encryption key with a given length.
 	 *
-	 * @param  integer  $keyLength  desired key length
-	 * @return string
+	 * @param integer $keyLength Desired key length
+	 * @return string The encryption key
 	 */
 	protected function createEncryptionKey($keyLength = 96) {
 		$bytes = t3lib_div::generateRandomBytes($keyLength);
